

function updateCart() {
	$.ajax({
		url: 'index.php?route=checkout/cart/refresh',
		type: 'post',
		data: '',
		dataType: 'json',			
		success: function(json) {			

			if (json['success']) {		

				if ($('.journal-cart').length) {
					setTimeout(function () {
						$('#cart-total').html(json['total']);
					}, 100);                                               
		
					$('#cart ul').load('index.php?route=common/cart/info ul li');
				} else {				
					/* Need to set timeout otherwise it wont update the total */
					setTimeout(function () {
						$('#cart > button.btn').html('<span id="cart-total"><i class="fa fa-shopping-cart"></i> ' + json['total'] + '</span>');
					}, 100);				

					$('#cart > ul').load('index.php?route=common/cart/info ul li');
				}
			} 
		}
	});
}

$(document).delegate('a[href=\'#collapse-shipping-address\']', 'click', function() {		
	updateCart();
});


$(document).delegate('a[href=\'#collapse-shipping-method\']', 'click', function() {		
	updateCart();
});

$(document).delegate('a[href=\'#collapse-payment-method\']', 'click', function() {	
	updateCart();
});

$(document).delegate('a[href=\'#collapse-checkout-confirm\']', 'click', function() {	
	updateCart();
});

function owc_euvat_confirm_ip() {  	
  if ($('#d_quickcheckout').length > 0) {
    preloaderStart();  
  }
       
  $.ajax({
		url: "index.php?route=checkout/payment_address/owc_euvat_confirm_ip",		
		method: 'POST',
		dataType: "json",
		data: 'confirm='+ $('.owc_euvat_confirm_ip').prop('checked') + '&address_id=' + $('#payment-address select[name=\'address_id\']').val(),
		success:function( data ) { 
		  if ($('#d_quickcheckout').length > 0) {
        preloaderStop();  
      }               
			$('.alert, .alert-danger').remove();                     	              
		}
  });     
}

function ajaxCheckVatnumber(field_prefix, elVatnumber, elCountry) {	 
  ajaxCheckVatnumberProgress(field_prefix, elVatnumber, elCountry, true); 
}

function ajaxCheckVatnumberProgress(field_prefix, elVatnumber, elCountry, showProgress) {	     
    
	var node = $('.group-euvat.' + elVatnumber.substring(1));		
	if (node.length == 0) {
	  node = $(elVatnumber);
  }
	
	if (!checkLocalAddressVATNumberIsChanged(field_prefix, elVatnumber)) {
	  console.log('VAT number is not changed: ' + field_prefix + ' ' + elVatnumber); 	
	  var addressCache = getLocalAddressCache(field_prefix);	
	  autoFillCompanyandAddress(addressCache, field_prefix, true);
	  return;
	}
	
	var customer_group_id = getSelectedCustomerGroupId(field_prefix);
	
	$.ajax({
			url: "index.php?route=checkout/payment_address/ajaxCheckVatnumber",			
			method: 'POST',
			dataType: "json",
			data: 'vatnumber='+ $(elVatnumber).val() + '&country_id=' + $(elCountry).val() + '&customer_group_id=' + customer_group_id,
			beforeSend: function() {					
				if (showProgress) {
				  $(node).parent().find('.text-danger').remove();
				  $(node).parent().find('.text-success').remove(); 	
			    $(node).after('<i class="fa fa-circle-o-notch fa-spin"></i>');			
			  }
			},	
			complete: function() {				
				if (showProgress) $('.fa-spin').remove();			
			},	
			success:function( json ) {
			  $('.fa-spin').remove();	
				$(node).parent().find('.text-danger').remove();
				$(node).parent().find('.text-success').remove(); 			
				
				if (json['success']) {	
					if (showProgress) $(node).after('<div class="text-success">' + json['success'] + '</div>');	
					
					if (json['vatnumber']) {
					  $(elVatnumber).val(json['vatnumber']);
				  }
					
					if (json['autofill_company_address']) {
					  json['elVatnumber']         = elVatnumber;
					  json['vatnumber']           = $(elVatnumber).val();
					  console.log(field_prefix);
					  setLocalAddressCache(field_prefix, json);					  
					  autoFillCompanyandAddress(json, field_prefix, false);
					}					
				} else 
				if (json['error']) {					  
					if (showProgress) $(node).after('<div class="text-danger">' + json['error'] + '</div>');		
					if (json['autofill_company_address']) {	
					  removeLocalAddressCache(field_prefix);			  
					  resetCompanyandAddress(json, field_prefix);
					}						    
				}	else 
				if (json['autofill_company_address']) {	
				  removeLocalAddressCache(field_prefix);		
				  resetCompanyandAddress(json, field_prefix);
				}		
				if (json['reload']) {					
					if (typeof LoadCart === "function") {					  
					  LoadCart();
					} else					
					if (typeof loadCart === "function") {					  
					  loadCart();
					} else  
					if (json['journal']) {
						$(document).trigger('journal_checkout_reload_cart');
					} else 
					if (json['d_quickcheckout']) {					  
					}
					
					updateCart(); 	
				}					
			} 			
	});     	
}

function getSelectedCustomerGroupId(field_prefix) {
  
  /*var customer_group_id = $('input[name=\''+field_prefix+'customer_group_id\']:selected').val();
  if (customer_group_id !== undefined) {
    console.log('1:customer_group_id='+customer_group_id);
    return customer_group_id;
  }
  
  customer_group_id = $('input[name=\''+field_prefix+'customer_group_id\']:checked').val();
  if (customer_group_id !== undefined) {
    console.log('2:customer_group_id='+customer_group_id);
    return customer_group_id;
  }*/
  
  customer_group_id = $('input[name*=\'customer_group_id\']:selected').val();
  if (customer_group_id !== undefined) {
    console.log('3:customer_group_id='+customer_group_id);
    return customer_group_id;
  }
  
  customer_group_id = $('input[name*=\'customer_group_id\']:checked').val();
  if (customer_group_id !== undefined) {
    console.log('4:customer_group_id='+customer_group_id);
    return customer_group_id;
  }
  
  /* Onepage checkout personal_details[customer_group_id]  */
  customer_group_id = $('select[name=\'personal_details[customer_group_id]\']').val();
  if (customer_group_id !== undefined) {
    console.log('5:customer_group_id='+customer_group_id);
    return customer_group_id;
  } 
  console.log('customer_group_id not found');
  return -1;
}

function getFieldId(prefix, field) {
  if ($('#d_quickcheckout').length > 0 && field == 'country') {
    field = 'country_id';
  }  
  
  if (prefix.indexOf('%s') !== -1) {
	  field_id = prefix.replace('%s', field);       	  
	} else {
	  field_id = prefix + field;
  }
  if ($('#d_quickcheckout').length > 0) {	
    field_id = field_id.replace('-', '_'); 
  }
  return field_id;
}

function resetCompanyandAddress(json, prefix) {	
  data      = json['autofill_data'];	
	for (let field in data) {
	  field_id = getFieldId(prefix, field);	  
	  if (field != 'country' && field != 'country_id') {
      $('input[id=\'' + field_id + '\']').val('').prop('readonly', false);		    	
    }	else {
      $('select[id=\'' + field_id + '\']').prop('disabled', false);
      if ($('#' + field_id + 'country-hidden').length > 0) {	
        $('#' + field_id + 'country-hidden').remove();  
      }
    }
  }	
}
  
function ajaxInitEUVatCustomField(field_prefix, elVatnumber, elCountry) {
  $( document ).ready(function() {
    var vatnumber = $(elVatnumber).val();     
    if (vatnumber.length > 0) {
      ajaxCheckVatnumberProgress(field_prefix, elVatnumber, elCountry, true);     
    }
  });
}

function setLocalAddressCache(field_prefix, json) {
  //console.log( $('#'+field_prefix+'customer-group').find(":selected").val());
  var customer_group_id = $('#'+field_prefix+'customer-group').find(":selected").val();
  window.localStorage.setItem(field_prefix + customer_group_id, JSON.stringify(json));		
}

function getLocalAddressCache(field_prefix) {
  var customer_group_id = $('#'+field_prefix+'customer-group').find(":selected").val();
  return JSON.parse(window.localStorage.getItem(field_prefix+ customer_group_id));		
}

function removeLocalAddressCache(field_prefix) {
  var customer_group_id = $('#'+field_prefix+'customer-group').find(":selected").val();
  window.localStorage.removeItem(field_prefix+ customer_group_id);		
}

function checkLocalAddressVATNumberIsChanged(field_prefix, elVatnumber) {
  if ($('#payment-method .quickcheckout-content').length > 0) {  
    return true;  
  }
  
  var addressCache = getLocalAddressCache(field_prefix);
  if (addressCache) {
    return $(elVatnumber).val() != addressCache['vatnumber'];
  }
  return true 
}

function autoFillCompanyandAddress(json, prefix, fromCache) {
  if ($('#d_quickcheckout').length > 0) {	
    autoFillCompanyandAddressDv(json, prefix, fromCache) 
  } else {
    autoFillCompanyandAddressDefault(json, prefix); 
  }
}

function autoFillCompanyandAddressDefault(json, prefix) {	
	data      = json['autofill_data'];	
	readonly  = json['autofill_disable_fields'];		 	
		
	for (let field in data) {  
	  field_id = getFieldId(prefix, field);
    if (field != 'country' && field != 'country_id') {
      if (data[field] != null && data[field] != '') {		
    		$('input[id=\'' + field_id + '\']').val(data[field]).prop('readonly', readonly);		
    	} else {		
    		$('input[id=\'' + field_id + '\']').val('').prop('readonly', false);	
    	}
    }	else {
      if (data[field] != null && data[field] != '') {		
        $('select[id=\'' + field_id + '\'] option[value=\'' + data[field] + '\']').prop('selected', true);		
  		  $('select[id=\'' + field_id + '\']').trigger('change');		
  		  if (readonly) {
  		    setTimeout(function (field_id) {         
            $('select[id=\'' + field_id + '\']').prop('disabled', true);          
          }, 1000, field_id); 
          country_name = $('select[id=\'' + field_id + '\']').attr('name');
          $('select[id=\'' + field_id + '\']').after('<input id="' + field_id + 'country-hidden" type="hidden" name="' + country_name + '" value="'+ data[field] +'">')		
        }        	
		  } else {
		    $('select[id=\'' + field_id + '\']').prop('disabled', false);	
		    $('#' + field_id + 'country-hidden').remove();	
		  }
    }
  }  
} 

function autoFillCompanyandAddressDv(json, prefix, fromCache) {	  
	console.log('autoFillCompanyandAddressDv ' + prefix + ' ' + fromCache); 	 
	
	data      = json['autofill_data'];	
	readonly  = json['autofill_disable_fields'];	    	
	
	if (json['vatnumber']) {
	  console.log('set vat ' + json['vatnumber']); 	
	  $(json['elVatnumber']).val(json['vatnumber']);
  }
				
	for (let field in data) {  
	  field_id = getFieldId(prefix, field);   
    if (field != 'country' && field != 'country_id' && fromCache == true) {
      if (data[field] != null && data[field] != '') {		
        $('input[id=\'' + field_id + '\']').val(data[field]).prop('readonly', readonly);    			
    		if (field_id.startsWith('payment_address_')) {
  		    qc.paymentAddressView.model.set('payment_address.' + field.replace('-', '_'), data[field]);  
  		  } else
  		  if (field_id.startsWith('shipping_address_')) {
  		    qc.shippingAddressView.model.set('shipping_address.' + field.replace('-', '_'), data[field]);  
  		  }
    	} else {		
    		$('input[id=\'' + field_id + '\']').val('').prop('readonly', false);	
    	}
    } else 
    if (field == 'country' || field == 'country_id') {     
      if (data[field] != null && data[field] != '') {		
        $('select[id=\'' + field_id + '\'] option[value=\'' + data[field] + '\']').prop('selected', true);	 		  
		    if (fromCache==false) {  		      
  		    $('select[id=\'' + field_id + '\']').trigger('change');	     		      		   
  		  } else {  
  		    
  		    $(json['elVatnumber']).parent().find('.text-danger').remove();
				  $(json['elVatnumber']).parent().find('.text-success').remove(); 
  		    if (json['success']) {
  		      console.log('set success for ' + prefix); 	
  		      
					  $(json['elVatnumber']).after('<div class="text-success">' + json['success'] + '</div>');	
					  json['success'] = null;
					  setLocalAddressCache(prefix, json);
				  }
  		      		    
  		    if (readonly) {
            country_name = $('select[id=\'' + field_id + '\']').attr('name');
            
            $('select[id=\'' + field_id + '\']').prop('disabled', readonly);	
            $('select[id=\'' + field_id + '\']').after('<input id="' + field_id + 'country-hidden" type="hidden" name="' + country_name + '" value="'+ data[field] +'">')		
          }    
        }    			       		
		  } else {
		    $('select[id=\'' + field_id + '\']').prop('disabled', false);	
		    $('#' + field_id + 'country-hidden').remove();	
		  }
    }
  }    
} 

var eu_vat_number_custom_field_id=-1;

function bindQuickCheckoutEUVatCustomFieldInit() {  
  setTimeout(function () {
    bindQuickCheckoutEUVatCustomField(true);
  }, 100);   
}

function bindQuickCheckoutEUVatCustomFieldFocusOut() {
  bindQuickCheckoutEUVatCustomField(false);
}

function bindQuickCheckoutEUVatCustomField(init) {
  
  if ($('#d_quickcheckout').length > 0) {	
    
    console.log('bindQuickCheckoutEUVatCustomField');   
    
    $.ajax({
			url: "index.php?route=checkout/payment_address/ajaxGetEUVatCustomFieldId",			
			method: 'POST',
			dataType: "json",			
			success:function( json ) {
			  eu_vat_number_custom_field_id = json['owc_euvat_custom_field_id'];
			  
			  input = $('input[id*="custom_field"]');				
    		if (input.length > 1) {					
    			$.each(input, function() {						  			
      			field_id = $(this).prop('id');						
      			if (field_id.endsWith(eu_vat_number_custom_field_id)) {   			  	  			  
      			  if (field_id.startsWith('payment_address_')) {
      			    var addressCache = getLocalAddressCache('payment_address_');	
        			  $(this).focusout(function() {        			       			    
        			    ajaxCheckVatnumber('payment_address_', 'input[id="payment_address_custom_field.address.'+eu_vat_number_custom_field_id+'"]', '#payment_address_country_id');            
                });
                if (init !== undefined && init) {                  
                  if (addressCache) {
                    autoFillCompanyandAddress(addressCache, 'payment_address_', true);
                  }	else {
                    ajaxCheckVatnumberProgress('payment_address_', 'input[id="payment_address_custom_field.address.'+eu_vat_number_custom_field_id+'"]', '#payment_address_country_id', false);            
                  }
                }
              }          
              if (field_id.startsWith('shipping_address_')) {	
                var addressCache = getLocalAddressCache('shipping_address_');	
                $(this).focusout(function() {                  
                  ajaxCheckVatnumber('shipping_address_', 'input[id="shipping_address_custom_field.address.'+eu_vat_number_custom_field_id+'"]', '#shipping_address_country_id');              
                });
                if (init !== undefined && init) {
                  if (addressCache) {
                    autoFillCompanyandAddress(addressCache, 'shipping_address_', true);
                  } else {	
                    ajaxCheckVatnumberProgress('shipping_address_', 'input[id="shipping_address_custom_field.address.'+eu_vat_number_custom_field_id+'"]', '#shipping_address_country_id', false);                         
                  }
                }
              }		 
    				}					
    			});			
    		}						
			} 			
	  });        	
	} else 
    if ($('#payment-method .quickcheckout-content').length > 0) {  
		$.ajax({
			url: "index.php?route=checkout/payment_address/ajaxGetEUVatCustomFieldId",			
			method: 'POST',
			dataType: "json",			
			success:function( json ) {
			  eu_vat_number_custom_field_id = json['owc_euvat_custom_field_id'];  
			  ajaxCheckVatnumberProgress('input-payment-', 'input[id="input-payment-custom-field'+eu_vat_number_custom_field_id+'"]', '#payment-address select[name=\'country_id\']', false);                         
			  				
    	}				
		});  
	}		
}

$( document ).ready(function() {
  if ($('#d_quickcheckout').length > 0) {     
       
    bindQuickCheckoutEUVatCustomFieldInit();      
    
    preloaderStopDv = preloaderStop;
    preloaderStop = function preloaderStop() { 
      if ($('#qc_confirm_order').prop('disabled') == true) {
        console.log('preloaderStop'); 
        bindQuickCheckoutEUVatCustomFieldInit();
      }  
      preloaderStopDv(); 
    }   	
  }  else
  if ($('#payment-method .quickcheckout-content').length > 0) {  
     bindQuickCheckoutEUVatCustomFieldInit();       
     $('#input-payment-customer-group').change(function(){	
      console.log('customer_group_id'); 
      bindQuickCheckoutEUVatCustomFieldInit();    
      if (typeof loadCart === "function") {					  
			  loadCart();
		  }
     });
  }     
});

